#include "mainwindow.h"
#include <QApplication>
#include <iostream>
#include <QCursor>
#include <QResource>
#include <QFileInfo>
#include <QBitmap>
#include <signal.h>

void signalHandler(int param)
{
  std::cout <<"SIGINT\n";
  QApplication::exit(0);
}

int main(int argc, char *argv[])
{

    QCoreApplication::setAttribute(Qt::AA_ShareOpenGLContexts);
    QApplication a(argc, argv);

    MainWindow rootWindow;
    QPixmap cursor_pixmap = QPixmap(":x-cursor");

    bool t2 = QFileInfo::exists(":x-cursor");
    std::cout << "Cursor resource check:\n Pixmap exist? - "<< !cursor_pixmap.isNull() <<". resource exists? - " << t2<< std::endl;
    std::cout << "Note: (1)=true, (0)=false\n";

    QCursor cursor = QCursor(cursor_pixmap,0,0);
    QApplication::setOverrideCursor(cursor);

    rootWindow.resize(1920,1080);

    signal(SIGINT, signalHandler);
    rootWindow.show();

    return a.exec();
}
