#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <iostream>
#include "doublekeylist.h"
#include <fstream>
#include <QWindow>

#define DEFAULT_SIZE 20.0

DoubleKeyList keyList;

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    std::ofstream ttyBind;
    ttyBind.open("/sys/class/vtconsole/vtcon1/bind");
    if (ttyBind.is_open())
        ttyBind << "0";

}

MainWindow::~MainWindow()
{
    std::cout << "Exit application.\n";
    std::ofstream ttyBind;
    ttyBind.open("/sys/class/vtconsole/vtcon1/bind"); // enable VT console
    if (ttyBind.is_open())
        ttyBind << "1";
    delete ui;
}

void MainWindow::on_pushButton_minus_clicked()
{
    Value -= 1;
    updateLcd(Value);
}

void MainWindow::on_pushButton_plus_clicked()
{
    Value += 1;
    updateLcd(Value);

}

void MainWindow::keyPressEvent(QKeyEvent *event)
{
    int key=event->key();

    keyList.add(key);

    if (key==Qt::Key_Plus )
        Value += 1;

    else if(key==Qt::Key_Minus)
        Value -= 1;

    else if(key==Qt::Key_Asterisk)
        Value *= 2;

    else if(key==Qt::Key_Slash)
        Value /= 2;

    if (keyList.getCount() == 2)
    {
        int key1 = 0, key2 = 0;
        keyList.getKeys(&key1,&key2);
        if ((key2 == Qt::Key_Control && key1 == Qt::Key_C)){
            QApplication::exit(0);
        }
    }
    updateLcd(Value);
}

void MainWindow::keyReleaseEvent(QKeyEvent *event)
{
    keyList.remove(event->key());
}
void MainWindow::mouseReleaseEvent(QMouseEvent * event)
{
    switch (event->button()) {
        case Qt::LeftButton:
            ui->label_A->setText("LEFT");
            break;

        case Qt::RightButton:
           ui->label_A->setText("RIGHT");
            break;

        case Qt::MiddleButton:
           ui->label_A->setText("MIDDLE");
            break;

        default:
            ui->label_A->setText("default");
            break;

        }
}

void MainWindow::on_pushButton_clicked()
{


}


void MainWindow::on_lineEdit_textEdited(const QString &arg1)
{
    ui->label_A->setText(arg1);
}

void MainWindow::updateLcd(int value)
{
    ui->lcdNumber->display(value);
}

void MainWindow::updateFontSize(int size){
    QFont font = ui->label->font();
    font.setPointSize(size);
    ui->label->setFont(font);
    ui->label_2->setFont(font);
    ui->label_A->setFont(font);
    ui->label_A_2->setFont(font);
    ui->pushButton->setFont(font);
    ui->pushButton_plus->setFont(font);
    ui->pushButton_minus->setFont(font);
    ui->lineEdit->setFont(font);

}

void MainWindow::on_verticalSlider_valueChanged(int value)
{
    int size = (int)((float)value * (DEFAULT_SIZE/50.0));
    updateFontSize(size);
}
